(princ "220612-BL-ru")
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; методы для получения свойств примитивов чертежа, на основе его DXF-типа
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(setq commonGetters
      (list
        (cons "TYPE" 'getType)
        (cons "X" 'getCoordinate)
        (cons "Y" 'getCoordinate)
        (cons "Z" 'getCoordinate)
        (cons "LAYER" 'getLayer)
        (cons "COLOR" 'getColor)
				(cons "LWEIGHT" 'getLineWeight)
        )
      )

; сюда можно добавить любой тип примитива чертежа, если его ещё нет
(setq Getters
      (list
        (append
					'("INSERT")
					'(("NAME" . getName))
					commonGetters
					'(("@" . getAttribute))
					'(("FLIP_DY" . getFlipDY))
					'(("FLIP_DX" . getFlipDX))
					'(("VISIBILITY" . getVisibility))
					'(("SCALEX" . getScaleX))
					'(("ROTATION" . getRotation))
					'(("!NX" . getNX))
					)
        (append
          '("TEXT")
          commonGetters
          '(("STRING" . getTextString))
          '(("ALIGN" . getTextAlign))
          )
        (append
          '("MTEXT")
          commonGetters
          '(("STRING" . getTextString))
          '(("ALIGN" . getTextAlign))
          '(("ROT" . getTextRotation))
          )
        (append
          '("POINT")
          commonGetters
          )
				(append
					'("DIMENSION")
					commonGetters
					'(("SIZE" . getDimSize)
					  ("STYLE" . getDimStyle)
					  ("OVERRIDE" . getDimOverride)
					  )
					)
        (append
          '("LINE")
          commonGetters
					'(("LINETYPE" . getLineType))
          '(("LENGTH" . getLineLength))
          '(("DX" . getLineDelta))
          '(("DY" . getLineDelta))
          '(("DZ" . getLineDelta))
          )
        (append
          '("CIRCLE")
          commonGetters
          '(("RADIUS" . getRadius))
          )
        (append
          '("LWPOLYLINE")
          commonGetters
          '(("AREA" . getLwplArea))
          )
        (append
          '("MULTILEADER")
          commonGetters
          '(("STRING" . getTextString))
          )
        (list
          "HATCH"
          '("LAYER" . getLayer)
          '("COLOR" . getColor)
          '("AREA" . getLwplArea)
          )
        )
      )


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun getLineDelta (ename field)
  (list 
    (cons field
          ((cdr (assoc field ; выдает функцию
                  (list
                    (cons "DX" car)
                    (cons "DY" cadr)
                    (cons "DZ" caddr)
                    )
                  )
                )
           (mapcar '- ; применяемую к этому массиву разностей координат
                   (trans (cdr (assoc 11 (entget ename))) ename 1)
                   (trans (cdr (assoc 10 (entget ename))) ename 1)
                   )
           )
          )
    )
  )

(defun getNX (ename field)
  (list
    (cons field
					(cadr (assoc 210 (entget ename)))
	  )
    )
  )
(defun getScaleX (ename field)
	(list
		(cons field
					(cdr (assoc 41 (entget ename))))))

(defun getRotation (ename field)
	(list
		(cons field
					(myrtos (cdr (assoc 50 (entget ename))) 5))))

(defun getLineWeight (ename field)
  (list
    (cons field
					(cdr (assoc 370 (entget ename)))
	  )
    )
  )


(defun getFlipDY (ename field)
	(list
		(cons field
					(LM:getdynpropvalue 
						(vlax-ename->vla-object ename)
						"FLIP_DY")
					)
		)
	)

(defun getFlipDX (ename field)
	(list
		(cons field
					(LM:getdynpropvalue 
						(vlax-ename->vla-object ename)
						"FLIP_DX")
					)
		)
	)

(defun getVisibility (ename field)
	(list
		(cons field
					(LM:getdynpropvalue 
						(vlax-ename->vla-object ename)
						"Visibility1")
					)
		)
	)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun getCoordinate (ename field / crd)
	(setq crd (ass 10 (entget ename)))
	(list (if crd 
					(progn
						(setq crd (trans crd ename 1))
						(cons field ((ass field (list (cons "X" car)
																					(cons "Y" cadr)
																					(cons "Z" caddr)))
												 crd)))
					; else
					(cons field "-"))))
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
(defun getLwplArea (ename field)
  (list (cons field (vlax-get-property (vlax-ename->vla-object
                                         ename)
                                       'Area)))
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun getLineType (ename field)
  (list (cons field (cdr (assoc 6 (entget ename)))))
  )
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun getLineLength (ename field)
  (list (cons field (round (* 1000 (vlax-get-property
                      (vlax-ename->vla-object
                        ename)
                      'Length)))
              )
        )
  )
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun getTextString (ename field)
  (list (cons field (vlax-get-property
                      (vlax-ename->vla-object ename)
                      'TextString)))
  )
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun getTextAlign (ename field / entity)
  (setq entity (entget ename))
  (list (cons field 
              (strcat
                (cdr (assoc (cdr (assoc 73 entity))
                            '((0 . "") (1 . "B") (2 . "M") (3 . "T"))
                            )
                     )
                (cdr (assoc (cdr (assoc 72 entity))
                            '((0 . "L") (1 . "C") (2 . "R") (3 . ".A") (4 . ".M") (5 . ".F"))
                            )
                     )
                )
              )
        )
  )
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun getTextRotation (ename field)
  (list (cons field (cdr (assoc 50 (entget ename)))))
  )
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun getRadius (ename field)
  (list (cons field (cdr (assoc 40 (entget ename)))))
  )
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun getLayer (ename field)
  (list (cons field (cdr (assoc 8 (entget ename)))))
  )
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun getDimSize (ename field)
  (list (cons field (cdr (assoc 42 (entget ename)))))
  )
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun getDimStyle (ename field)
  (list (cons field (cdr (assoc 3 (entget ename)))))
  )
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun getDimOverride (ename field)
  (list (cons field (cdr (assoc 1 (entget ename)))))
  )
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun getColor (ename field)
  (list (cons field (cdr (assoc 62 (entget ename)))))
  )
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun getType (ename field)
  (list (cons field (cdr (assoc 0 (entget ename)))))
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun getAttribute (ename field)
	(if (= (strlen field) 1)
		; выдать список доступных атрибутов, приписав к ним собаку
		(mapcar '(lambda (attr) (cons (strcat "@" (car attr)) (deleteTags (cdr attr))))
						(LM:getattributevalues ename))
		;else
		; выдать значение атрибута, убрав у названия собаку
		(list (cons field
								(LM:getattributevalue ename (substr field 2 (1- (strlen field))))))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; получаем имя из блока,  в том числе динамического
(defun getName (ename field / rawname)
  (setq rawname (cdr (assoc 2 (entget ename))))
  (list 
    (cons
      field 
      (if (= "*" (substr rawname 1 1))
	(cdr
	  (assoc
	    2 (entget
		(cdr
		  (assoc
		    340 (entget
			  (cdr
			    (assoc
			      360 (entget
				    (cdr
				      (assoc
					360 (entget
					      (cdr
						(assoc
						  360
						  (entget ename)
						  )
						)
					      )
					)
				      )
				    )
			      )
			    )
			  )
		    )
		  )
		)
	    )
	  )
	rawname
	)
      )
    )
  )
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; функции для таблицы
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; вычисляем длину вектора, беря его из строки
(defun lva (str)
  (lvec
            (mapcar 'distof
                    (cut 2 (cdr (sliceString str " ")))))
  )
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; вычисляем корень из суммы квадратов
(defun lv (lst)
  (sqrt
    (apply '+
           (mapcar '(lambda (x) (* x x))
                   lst
                   )
           )
    )
  )
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; вычисляем длину вектора из двух координат, в строках
(defun lvdev (dx dy)
  (lv
    (mapcar 'distof
            (list dx dy)
            )
    )
  )

(defun secline (str)
  ; выводим вторую строчку из кода
  ; спец функция для таблицы
  (distof (cadr (listlog "slice" (sliceString str "}\\P"))))
  )

(defun <dsurf (str1 str2)
  (< (abs (secline str1)) (abs (secline str2)))
  )
(defun >dsurf (str1 str2)
  (> (abs (secline str1)) (abs (secline str2)))
  )
