; это основной файл всего пакета
; он загружает вместе с собой все остальные модули, создает список команд
; и объявляет команду c:pt_starter, которая показывает этот список
(if pt_starter ; запущено с кнопки
  (progn
    (setq pt_root (strcat (vl-filename-directory pt_starter) "/"))
    (setcfg "AppData/pt/root" pt_root)
    (setq pt_starter nil) ; обнуляем результат
    )
  (setq pt_root (getcfg "AppData/pt/root")))

(while
  (not (and pt_root (vl-file-size (strcat pt_root "pt_starter.lsp"))))
  (setq pt_root (strcat (vl-filename-directory (getfiled "Укажите файл pt_starter.lsp" "" "" 2)) "/"))
  (setcfg "AppData/pt/root" pt_root))

(setq pt_commands nil)
(setq pt_commands_settings nil)

;_для записи данных в строку-подсказку
(defun declare (name comment)
  (setq pt_commands
        (cons (list name comment pt-now-loading)
              pt_commands)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; записываем расшифровку настроек
(defun declare-setting (name comment default)
  (setq pt_settings (cons (list name comment default) pt_settings))
  (use-setting name))

; припишем имя настройки к списку команд
(defun use-setting (name)
  (setq
    pt_commands 
    (cons
      (append (car pt_commands) (list name))
      (cdr pt_commands))))

; приписываем краткое описание к команде
(defun declare-description (descr)
	; TODO реализуй
	; убираются все начальные пустые строки
	(setq descr nil))

(setq last_time nil)
(setq start_time (getvar "MILLISECS"))
(setq pt_load_failure nil)
;загружаем ключ в переменную pt_key
(setq pt_key (getcfg "AppData/pt/key"))
(princ "\n")

(defun timestamp (x) 'timestamp)

; здесь загружаем все, что подходит под паттерн "pt_*.lsp"
(foreach
  file
  (vl-remove
    "pt_starter.lsp" ; и самого стартера
    (append
      (vl-directory-files pt_root "pt_*.lsp")
      (vl-directory-files pt_root "pt_*.des")
      (vl-directory-files pt_root "pt_*.fas")))
  (princ (strcat file ": "))
  (setq pt-now-loading (vl-filename-base file))
  (load (strcat pt_root file))
  ;(princ (strcat "loaded file: " file "\n"))
  (princ "\n"))

; задекларим пускач с настройками перед сортировкой
(declare "pt_starter" "Запуск окна с командами")
(declare-setting "STARTER_LIST_WIDTH" "Ширина окна выбора команды" "150")
(declare-setting "STARTER_LIST_HEIGHT" "Высота окна выбора команды" "45")
(declare-setting "STARTER_LIST_TABS" "Ширина колонки в окне выбора команды" "16")

; и отсортируем уж по алфавиту все команды, которые загрузились
(setq pt_commands (vl-sort pt_commands
                           '(lambda (a1 a2) (< (car a1) (car a2)))))

(if pt_load_failure
	(setq pt_commands
				(cons
					(list "-------" "-------" "-------")
					(cons (list "pt-lic" "НЕ ВСЕ МОДУЛИ ЗАГРУЖЕНЫ. Запустите эту строку для получения доступа ко всем модулям." "-------")
								(cons
									(list "-------" "-------" "-------")
									pt_commands)))))

(setq pt_last_commands nil)
(setq PT_LC_AMOUNT 15) ; сколько последних команд мы запоминаем

(timestamp "primitive tools загружены за")

(setq pt_loaded T)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; команда для самоперезагрузки
(defun c:pt_reload ()
  (load (strcat pt_root "pt_starter.lsp")))

(defun c:pt_starter ( / pt_dialogue_result whole-list)
	; загружаем из настроек размеры диалогового окна
	; и сразу переписываем, если надо, конфиг файл
	(changefile (strcat pt_root "pt_runapp.dcl")
							(list ; список поиска и подстановки
								(list "width=*" (strcat "width=" (pt:settings "STARTER_LIST_WIDTH" "R" "150") ";"))
								(list "height=*" (strcat "height=" (pt:settings "STARTER_LIST_HEIGHT" "R" "50") ";"))
								(list "tabs=*" (strcat "tabs=" (pt:settings "STARTER_LIST_TABS" "R" "15") ";" ))))
	(setq pt_dialogue_result
				(pt:chooser "Choose script to launch"
										"pt_runapp.dcl"
										(mapcar '(lambda (x)
															 (strcat (car x) "\t" 
																			 ((lambda (y)
																					(if (listp y) (car y) y))
																				(cadr x))))
														(setq whole-list
																	(append (if pt_last_commands
																						(append
																							pt_last_commands
																							'(("" ""))
																							))
																					pt_commands)))))

	(if pt_dialogue_result
		(progn
			(setq pt_command (car (nth (atoi pt_dialogue_result) whole-list)))
			(varlog "pt_command" pt_command)
			(if (= "*" (substr pt_command 1 1))
				(command (substr pt_command 2))
				(vla-SendCommand (vla-get-activedocument (vlax-get-acad-object)) (strcat pt_command "\n")))))
	; добавим вызванную команду, если она есть в список последних вызваных
	; правила такие: если вызвана команда, которой не было в списке
	; последних, она добавляется, если при этом количество становится
	; больше допустимого, самая старая команда удаляется из списка
	; если команда уже есть в списке, она не добавляется
	(if pt_command
		((lambda (cmd)
			 (if (member cmd pt_last_commands) 
				 (setq pt_last_commands
							 (cons cmd (vl-remove cmd pt_last_commands)))
				 (setq pt_last_commands
							 (cut PT_LC_AMOUNT 
										(cons cmd pt_last_commands)))))
		 (assoc pt_command pt_commands)))
	(princ))
'r
